SystemOrganization addCategory: #'MC2-Tests-Repository-Directory'!

MDRepositoryTest subclass: #MDDirectoryRepositoryTest
	instanceVariableNames: 'directory tearDownRepositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Tests-Repository-Directory'!

!MDDirectoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 8/18/2008 20:03'!
directoryName
	^ 'TestRepository'! !

!MDDirectoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 10/27/2008 23:45'!
newRepository
	^ self noteRepository: (MDDirectoryRepository on: directory)! !

!MDDirectoryRepositoryTest methodsFor: 'running' stamp: 'cwp 10/27/2008 23:45'!
noteRepository: aRepository 
	^ tearDownRepositories add: aRepository! !

!MDDirectoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 10/27/2008 23:45'!
secondRepository
	| dirName dir |
	dirName := self directoryName , '2'.
	dir := FileDirectory default directoryNamed: dirName.
	^ self noteRepository: (MDDirectoryRepository on: dir)! !

!MDDirectoryRepositoryTest methodsFor: 'running' stamp: 'cwp 10/27/2008 23:43'!
setUp
	directory := FileDirectory default directoryNamed: self directoryName.
	tearDownRepositories := OrderedCollection new.
	super setUp! !

!MDDirectoryRepositoryTest methodsFor: 'running' stamp: 'cwp 10/22/2009 00:13'!
tearDown
	| dir |
	super tearDown.
	tearDownRepositories do: 
		[:ea | 
		dir := ea instVarNamed: 'directory'.
		ea close.
		dir ifNotNil: [dir recursiveDelete]].
! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/25/2008 15:37'!
testDiscovery
	| version retrieved file |
	version := MDTestBuilder new version.
	file := MDFileRepository on: 
		(directory newFileNamed: 'fb6a3295-edc1-47c3-aaa2-588649a0c11d.mcr').
	file put: version.
	file close.
	retrieved := repository get: version hashstamp.
	self assert: retrieved = version! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/21/2009 23:45'!
testLoad
	| newName properties |
	newName := repository name , '-Renamed'.
	properties := MDPropertyDictionary new
		name: newName;
		yourself.
	repository properties: properties.
	self assert: repository name = newName.
	self assert: (FileDirectory default directoryExists: newName).! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/21/2009 23:47'!
testLoadNewInstance
	| newName properties newRepository |
	newName := repository name , '-Renamed'.
	properties := MDPropertyDictionary new
		name: newName;
		primaryName: 'abc';
		yourself.
	newRepository := MDDirectoryRepository id: MDHashstamp new.
	self noteRepository: newRepository.
	newRepository properties: properties.
	self assert: newRepository name = newName.
	self assert: (FileDirectory default directoryExists: newName)! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'jf 11/8/2009 17:24'!
testLoadPrimaryName
	| newName properties |
	newName := 'abc'.
	properties := MDPropertyDictionary new
		name: repository name;
		primaryName: newName;
		yourself.
	repository properties: properties.
	self assert: repository primaryName = newName.
	self assert: ((FileDirectory default directoryNamed: repository name) 
					fileExists: repository primaryFilename).! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 8/21/2008 20:23'!
testNameFromDirectory
	self assert: repository name = 'TestRepository'! !
